#!/usr/bin/perl
# 
# library - make 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.02;
	# 
	# ver 0.00 [2004/04/20] 
	# ver 0.01 [2004/06/02] RSS/Atom Feed б
	# ver 0.02 [2004/06/21] sbmake_cookie_js ɲ / sbmake_atom 
}

sub sbmake_check_template { # ѥƥץ졼Ȥγǧ
	my $mode = shift;
	my $temp = '';
	&sbfile_read_datafile('temp') if ($gData{'num'}{'temp'} eq ''); # ƥץ졼Ȥɤ߹ޤƤʤˤɤ߹
	for (my $i=0;$i<$gData{'num'}{'temp'};$i++) {
		next if ($gData{'temp'}[$i]{'id'} eq '');
		next if (!$gData{'temp'}[$i]{'use'});
		$temp = $gData{'temp'}[$i]{'main'};
		$temp = $gData{'temp'}[$i]{'entry'} if ($mode eq 'ent' and $gData{'temp'}[$i]{'entry'} ne '');
	}
	return($temp);
}
sub sbmake_build_init {
	$gData{'{site_css}'}[0]      = $gEnv{srv}{base} . $gEnv{file}{css};
	$gData{'{site_cgi}'}[0]      = $gEnv{srv}{cgi} . $gEnv{basic}{sb};
	$gData{'{site_rss}'}[0]      = $gEnv{srv}{base} . $gEnv{dir}{log} . $gEnv{file}{rss};
	$gData{'{site_atom}'}[0]     = $gEnv{srv}{base} . $gEnv{dir}{log} . $gEnv{file}{atom};
	$gData{'{site_top}'}[0]      = $gEnv{srv}{base};
	$gData{'{site_encoding}'}[0] = $gMsg{'parts'}{'code'};
	$gData{'{site_lang}'}[0]     = $gEnv{conf}{lang};
	$gData{'{site_title}'}[0]    = $gEnv{conf}{blog_title};
	return();
}
sub sbmake_rebuild_all {
	my $type = $gEnv{'conf'}{'entry_archive'};
	if ($type ne 'None') {
		my @order = ();
		my @lists = ();
		&sbfile_read_datafile('ent') if ($gIn{'num'}{'ent'} eq '');
		@order = @{$gData{'ent'}};
		@order = sort { $$b{'date'} <=> $$a{'date'} } @order;
		foreach my $hash ( @order ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ȥ꡼Ф
			push(@lists,$$hash{'id'}) if ($type eq 'Individual');
			push(@lists,&sbtime_stamp($$hash{'date'},'%yr%mo',$gEnv{'conf'}{'timezone'},'en')) if ($type eq 'Monthly');
		}
		if ($type eq 'Monthly') {
			my %cnt;
			@lists = grep(!$cnt{$_}++, @lists);
		} elsif ($type eq 'Individual') {
			&sbmake_alljs();
		}
		foreach my $list ( @lists ) {
			&sbmake_entry($list) if ($type eq 'Individual');
			&sbmake_month($list) if ($type eq 'Monthly');
		}
	}
	&sbmake_top();
	&sbmake_rss()  if ($gEnv{'basic'}{'gen_rss'});
	&sbmake_atom() if ($gEnv{'basic'}{'gen_atom'});
	&sbmake_css();
	&sbmake_cookie_js();
	return();
}
sub sbmake_alljs {
	foreach my $type ('ent','com','tb','aws','user','link','cat') { # ꥹȥեɹ
		&sbfile_read_datafile($type) if ($gIn{'num'}{$type} eq '');
	}
	{ # ꥹȥץѽ
		&sbmake_build_init();
		&sbcms_listblock();   # ꥹȥ֥å
		&sbcms_recent_list(); # ǿ / ȥåХå
		&sbcms_entrylist();   # ȥ꡼Ϣ֥å (ǿȥ꡼ / ƥ꡼ / )
		&sbcms_calendar();    # 
	}
	foreach my $elem ( keys(%{$gEnv{'listjs'}}) ) {
		my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'listjs'}{$elem}{'js'};
		my $text = $gData{'{' . $elem . '}'}[0];
		open(JSOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
		binmode(JSOUT);
		foreach my $line ( split("\n",$text) ) {
			print JSOUT 'document.write(\'' . $line . '\\n\');',"\n";
		}
		close(JSOUT);
	}
	return();
}
sub sbmake_comjs { # ǿ/ȥåХåꥹȤ
	foreach my $type ('ent','com','tb') { # ꥹȥեɹ
		&sbfile_read_datafile($type) if ($gIn{'num'}{$type} eq '');
	}
	&sbmake_build_init();
	&sbcms_recent_list();
	foreach my $elem ('recent_comment_list','recent_trackback_list') {
		my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'listjs'}{$elem}{'js'};
		my $text = $gData{'{' . $elem . '}'}[0];
		open(JSOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
		binmode(JSOUT);
		foreach my $line ( split("\n",$text) ) {
			print JSOUT 'document.write(\'' . $line . '\\n\');',"\n";
		}
		close(JSOUT);
	}
	return();
}
sub sbmake_top {
	my $temp = &sbmake_check_template('main');
	my $file = $gEnv{'dir'}{'base'} . $gEnv{'file'}{'index'};
	{ # ȥåץڡѽ
		&sbmake_build_init();
		$gIn{'page'} = 0;
		$gIn{'month'} = '';
		$gIn{'day'} = '';
		&sbcms_parseblock($temp);
		&sbcms_main('page');
	}
	open(TOPOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
	binmode(TOPOUT);
	print TOPOUT &sbcms_output();
	close(TOPOUT);
	return();
}
sub sbmake_entry {
	my $eid = shift;
	return() if ($eid eq '');
	my $temp = &sbmake_check_template('ent');
	my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'basic'}{'preid'} . $eid . $gEnv{'basic'}{'suffix'};
	{ # ̥ȥ꡼ڡѽ
		&sbmake_build_init();
		$gIn{'eid'} = $eid;
		&sbcms_parseblock($temp);
		&sbcms_main('ent');
	}
	open(ENTOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
	binmode(ENTOUT);
	print ENTOUT &sbcms_output();
	close(ENTOUT);
	return();
}
sub sbmake_month {
	my $month = shift;
	return() if ($month eq '');
	my $temp = &sbmake_check_template('main');
	my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'log'} . $month . $gEnv{'basic'}{'suffix'};
	{ # ̥֥ڡѽ
		&sbmake_build_init();
		$gEnv{'conf'}{'page_disp'} = 0;
		$gIn{'page'} = 0;
		$gIn{'month'} = $month;
		&sbcms_parseblock($temp);
		&sbcms_main('arc');
	}
	open(MONTHOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
	binmode(MONTHOUT);
	print MONTHOUT &sbcms_output();
	close(MONTHOUT);
	return();
}
sub sbmake_css {
	return() if (-s $gEnv{dir}{base} . $gEnv{file}{css}); # 륷ȤƤ褦ʤ鲿⤷ʤ
	&sbfile_read_datafile('temp') if ($gData{'num'}{'temp'} eq ''); # ƥץ졼Ȥɤ߹ޤƤʤˤɤ߹
	for (my $i=0;$i<$gData{'num'}{'temp'};$i++) {
		next if ($gData{'temp'}[$i]{'id'} eq '');
		next if (!$gData{'temp'}[$i]{'use'});
		&sbfile_update_css($gData{'temp'}[$gData{'temp'}[$i]{'id'}]{'css'},$gEnv{dir}{base} . $gEnv{file}{css});
	}
	return();
}
sub sbmake_rss {
	my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'file'}{'rss'};
	my $aRssNum  = $gEnv{'basic'}{'gen_rss'};
	my $aRssSum  = 200;
	my $aRssTime = '%yr-%mo-%dyT%hr:%mi:%sc' . substr($gEnv{'conf'}{'timezone'},0,3) . ':' . substr($gEnv{'conf'}{'timezone'},3,2);
	my $aRssTemp = <<'_RSS_TEMPLATE_';
<?xml version="1.0" encoding="utf-8"?>
<rdf:RDF
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns="http://purl.org/rss/1.0/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:content="http://purl.org/rss/1.0/modules/content/"
    xmlns:cc="http://web.resource.org/cc/"
    xml:lang="{sb_rss_lang}">
  <channel rdf:about="{sb_rss_url}">
    <title>{sb_rss_site_title}</title>
    <link>{sb_rss_site_url}</link>
    <description>{sb_rss_site_description}</description>
    <dc:language>{sb_rss_lang}</dc:language>
    <items>
      <rdf:Seq>
        <!-- BEGIN sb_rss_entrylist -->
        <rdf:li rdf:resource="{sb_rss_list_url}" />
        <!-- END sb_rss_entrylist -->
      </rdf:Seq>
    </items>
  </channel>
  <!-- BEGIN sb_rss_entry -->
  <item rdf:about="{sb_rss_entry_url}">
    <link>{sb_rss_entry_url}</link>
    <title>{sb_rss_entry_subj}</title>
    <description>{sb_rss_entry_sum}</description>
    <content:encoded><![CDATA[{sb_rss_entry_body}]]></content:encoded>
    <dc:subject>{sb_rss_entry_cate}</dc:subject>
    <dc:date>{sb_rss_entry_date}</dc:date>
    <dc:creator>{sb_rss_entry_author}</dc:creator>
    <dc:publisher>sb</dc:publisher>
    <dc:rights>{sb_rss_entry_author}</dc:rights>
  </item>
  <!-- END sb_rss_entry -->
</rdf:RDF>
_RSS_TEMPLATE_
	{ # 
		&sbmake_build_init();
		$aRssTemp = &sbtxt_ent(&sbtxt_lfconv($aRssTemp,0));
		&sbfile_read_datafile('ent') if ($gIn{'num'}{'ent'} eq '');
	}
	{ # 
		$gData{'{sb_rss_url}'}[0]              = $gEnv{srv}{base} . $gEnv{dir}{log} . $gEnv{file}{rss};
		$gData{'{sb_rss_site_url}'}[0]         = $gEnv{srv}{base};
		$gData{'{sb_rss_lang}'}[0]             = $gEnv{conf}{lang};
		$gData{'{sb_rss_site_title}'}[0]       = $gEnv{conf}{blog_title};
		$gData{'{sb_rss_site_description}'}[0] = &sbtxt_lfconv($gEnv{'conf'}{'blog_desc'},1);
		$gData{'{sb_rss_site_description}'}[0] =~ tr/\x0D\x0A//d;
	}
	{ # ȥ꡼
		my @lists = ();
		@order = @{$gData{'ent'}};
		@order = sort { $$b{'date'} <=> $$a{'date'} } @order;
		foreach my $hash ( @order ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ȥ꡼Ф
			push(@lists,$$hash{'id'});
		}
		my $num = 0;
		foreach my $eid ( @lists ) {
			&sbfile_read_entry($eid);
			my $data = $gData{'entry'}{$eid}{'ent'};
			my $body = &sbtxt_det($$data{'body'});
			$body = ($$data{'form'}) ? &sbtxt_lfconv($body,2) : &sbtxt_lfconv($body,1);
			$gData{'{sb_rss_list_url}'}[$num]     = &sbcms_permalink($eid,$$data{'date'});
			$gData{'{sb_rss_entry_url}'}[$num]    = &sbcms_permalink($eid,$$data{'date'});
			$gData{'{sb_rss_entry_sum}'}[$num]    = &sbcms_make_summary($$data{'sum'},$$data{'body'},$aRssSum);
			$gData{'{sb_rss_entry_subj}'}[$num]   = $$data{'subj'};
			$gData{'{sb_rss_entry_body}'}[$num]   = $body;
			$gData{'{sb_rss_entry_cate}'}[$num]   = $$data{'cat'};
			$gData{'{sb_rss_entry_date}'}[$num]   = &sbtime_stamp($$data{'date'},$aRssTime,$gEnv{'conf'}{'timezone'},'en');
			$gData{'{sb_rss_entry_author}'}[$num] = ($gData{'user'}[$$data{'auth'}]{'id'} eq '') ? $gData{'user'}[0]{'real'} : $gData{'user'}[$$data{'auth'}]{'real'};
			delete($gData{'entry'}{$eid}); # Ѥȥ꡼ǡ
			$num++;
			last if ($num == $aRssNum);
		}
		$gEnv{'block'}{'sb_rss_entrylist'} = $num;
		$gEnv{'block'}{'sb_rss_entry'} = $num;
	}
	{ # 
		my $rssbody = '';
		&sbcms_parseblock($aRssTemp);
		$rssbody = &sbcms_output();
		$rssbody = &sblang_conv($rssbody,'utf8',$gEnv{'code'}) if ($gEng{'code'} ne 'utf8');
		open(RSSOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
		binmode(RSSOUT);
		print RSSOUT $rssbody;
		close(RSSOUT);
	}
	return();
}
sub sbmake_atom {
	my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'file'}{'atom'};
	my $aAtomNum   = $gEnv{'basic'}{'gen_atom'};
	my $aAtomSum   = 200;
	my $aAtomTime  = '%yr-%mo-%dyT%hr:%mi:%scZ';
	my $aAtomIssue = '%yr-%mo-%dyT%hr:%mi:%sc' . substr($gEnv{'conf'}{'timezone'},0,3) . ':' . substr($gEnv{'conf'}{'timezone'},3,2);
	my $aAtomTemp  = <<'_ATOM_TEMPLATE_';
<?xml version="1.0" encoding="utf-8" ?>
<feed version="0.3" xml:lang="{sb_atom_lang}" xmlns="http://purl.org/atom/ns#" xmlns:dc="http://purl.org/dc/elements/1.1/">
	<title>{sb_atom_site_title}</title>
	<link rel="alternate" type="text/html" href="{sb_atom_site_url}" />
	<modified>{sb_atom_site_date}</modified>
	<tagline>{sb_atom_site_description}</tagline>
	<generator url="http://nz.jugemers.net/">sb</generator>
	<!-- BEGIN sb_atom_entry -->
	<entry>
		<title>{sb_atom_entry_subj}</title>
		<link rel="alternate" type="text/html" href="{sb_atom_entry_url}" />
		<id>{sb_atom_entry_url}</id>
		<issued>{sb_atom_entry_iss}</issued>
		<modified>{sb_atom_entry_mod}</modified>
		<summary>{sb_atom_entry_sum}</summary>
		<author>
			<name>{sb_atom_entry_auth}</name>
		</author>
		<dc:subject>{sb_atom_entry_cate}</dc:subject>
		<content mode="escaped" type="text/html" xml:lang="{sb_atom_lang}"><![CDATA[{sb_atom_entry_body}]]></content>
	</entry>
	<!-- END sb_atom_entry -->
</feed>
_ATOM_TEMPLATE_
	{ # 
		&sbmake_build_init();
		$aAtomTemp = &sbtxt_ent(&sbtxt_lfconv($aAtomTemp,0));
		&sbfile_read_datafile('ent') if ($gIn{'num'}{'ent'} eq '');
	}
	{ # 
		$gData{'{sb_atom_site_url}'}[0]         = $gEnv{srv}{base};
		$gData{'{sb_atom_lang}'}[0]             = $gEnv{conf}{lang};
		$gData{'{sb_atom_site_title}'}[0]       = $gEnv{conf}{blog_title};
		$gData{'{sb_atom_site_date}'}[0]        = &sbtime_stamp($gNowTime,$aAtomTime,'+0000','en');
		$gData{'{sb_atom_site_description}'}[0] = &sbtxt_lfconv($gEnv{'conf'}{'blog_desc'},1);
		$gData{'{sb_atom_site_description}'}[0] =~ tr/\x0D\x0A//d;
	}
	{ # ȥ꡼
		my @lists = ();
		@order = @{$gData{'ent'}};
		@order = sort { $$b{'date'} <=> $$a{'date'} } @order;
		foreach my $hash ( @order ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ȥ꡼Ф
			push(@lists,$$hash{'id'});
		}
		my $num = 0;
		foreach my $eid ( @lists ) {
			&sbfile_read_entry($eid);
			my $data = $gData{'entry'}{$eid}{'ent'};
			my $body = &sbtxt_det($$data{'body'});
			$body = ($$data{'form'}) ? &sbtxt_lfconv($body,2) : &sbtxt_lfconv($body,1);
			$gData{'{sb_atom_entry_url}'}[$num]  = &sbcms_permalink($eid,$$data{'date'});
			$gData{'{sb_atom_entry_sum}'}[$num]  = &sbcms_make_summary($$data{'sum'},$$data{'body'},$aAtomSum);
			$gData{'{sb_atom_entry_subj}'}[$num] = $$data{'subj'};
			$gData{'{sb_atom_entry_body}'}[$num] = $body;
			$gData{'{sb_atom_entry_cate}'}[$num] = $$data{'cat'};
			$gData{'{sb_atom_entry_iss}'}[$num]  = &sbtime_stamp($$data{'date'},$aAtomIssue,$gEnv{'conf'}{'timezone'},'en');
			$gData{'{sb_atom_entry_mod}'}[$num]  = &sbtime_stamp($$data{'date'},$aAtomTime,'+0000','en');
			$gData{'{sb_atom_entry_auth}'}[$num] = ($gData{'user'}[$$data{'auth'}]{'id'} eq '') ? $gData{'user'}[0]{'real'} : $gData{'user'}[$$data{'auth'}]{'real'};
			$gData{'{sb_atom_lang}'}[$num]       = $gData{'{sb_atom_lang}'}[0] if ($num > 0);
			delete($gData{'entry'}{$eid}); # Ѥȥ꡼ǡ
			$num++;
			last if ($num == $aAtomNum);
		}
		$gEnv{'block'}{'sb_atom_entry'} = $num;
	}
	{ # 
		my $atombody = '';
		&sbcms_parseblock($aAtomTemp);
		$atombody = &sbcms_output();
		$atombody = &sblang_conv($atombody,'utf8',$gEnv{'code'}) if ($gEng{'code'} ne 'utf8');
		open(ATOMOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
		binmode(ATOMOUT);
		print ATOMOUT $atombody;
		close(ATOMOUT);
	}
	return();
}
sub sbmake_cookie_js {
	my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'file'}{'cook'};
	return() if (-s $file);
	my $tag = $gEnv{'basic'}{'cooktag'};
	my $js_body = <<"_COOKIE_JS_";
var cookie = document.cookie.split(';');
var form_value = new Array();
for (var i=0;i<cookie.length;i++) {
	var cook_val = cookie[i].split('=');
	if (cook_val[0].indexOf('$tag') > -1) {
		var cook_detail = cook_val[1].split(',');
		for (var j=0;j<cook_detail.length;j++) {
			if (cook_detail[j].length > 0) {
				var key = cook_detail[j].split('<>');
				key[1] = decodeURIComponent(key[1]);
				form_value[key[0]] = key[1];
			}
		}
	}
}
var form_tag = document.getElementsByTagName('input');
for (var i=0;i<form_tag.length;i++) {
	var name = form_tag[i].getAttribute('name');
	if (name) {
		for (var j in form_value) {
			if (name.indexOf(j) > -1) {
				var check = form_tag[i].getAttribute('value');
				if (check.length == 0) form_tag[i].setAttribute('value',form_value[j]);
			}
		}
	}
}
_COOKIE_JS_
	open(COOKOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
	binmode(COOKOUT);
	print COOKOUT $js_body;
	close(COOKOUT);
	return();
}
1;
